#include <Wire.h>  //调用arduino自带的I2C库
#include <LiquidCrystal.h>   //调用arduino自带的LiquidCrystal库
 
#define Register_ID 0
#define Register_2D 0x2D
#define Register_X0 0x32
#define Register_X1 0x33
#define Register_Y0 0x34
#define Register_Y1 0x35
#define Register_Z0 0x36
#define Register_Z1 0x37
 
LiquidCrystal lcd(3, 2,4);//设置接口
 
int ADXAddress = 0xA7>>1;  //转换为7位地址
int reading = 0;
int val = 0;
int X0,X1,X_out;
int Y0,Y1,Y_out;
int Z1,Z0,Z_out;
double Xg,Yg,Zg;
 
void setup()
{

  lcd.begin(16, 2);  //初始化LCD
  delay(100);
  Wire.begin();  //初始化I2C
  delay(100);
  Wire.beginTransmission(ADXAddress);
  Wire.send(Register_2D);
  Wire.send(8);
  Wire.endTransmission();
  lcd.setBacklight(HIGH);
}
 
void loop()
{
  Wire.beginTransmission(ADXAddress);
  Wire.send(Register_X0);
  Wire.send(Register_X1);
  Wire.endTransmission();
  Wire.requestFrom(ADXAddress,2);
  if(Wire.available()<=2);
  {
    X0 = Wire.receive();
    X1 = Wire.receive();
    X1 = X1<<8;
    X_out = X0+X1;
  }
 
  Wire.beginTransmission(ADXAddress);
  Wire.send(Register_Y0);
  Wire.send(Register_Y1);
  Wire.endTransmission();
  Wire.requestFrom(ADXAddress,2);
  if(Wire.available()<=2);
  {
    Y0 = Wire.receive();
    Y1 = Wire.receive();
    Y1 = Y1<<8;
    Y_out = Y0+Y1;
  }
 
  Wire.beginTransmission(ADXAddress);
  Wire.send(Register_Z0);
  Wire.send(Register_Z1);
  Wire.endTransmission();
  Wire.requestFrom(ADXAddress,2);
  if(Wire.available()<=2);
  {
    Z0 = Wire.receive();
    Z1 = Wire.receive();
    Z1 = Z1<<8;
    Z_out = Z0+Z1;
  }
 
  Xg = X_out/256.00;//把输出结果转换为重力加速度g,精确到小数点后2位。
  Yg = Y_out/256.00;
  Zg = Z_out/256.00;
  lcd.clear(); //清屏
  lcd.print("X="); //使屏幕显示文字X=
  
  
  
  
  
  lcd.print(Xg);
  lcd.setCursor(8, 0);
  lcd.print("Y=");
  lcd.print(Yg);
  lcd.setCursor(0, 1);
  lcd.print("Z=");
  lcd.print(Zg);
  delay(300);  //延时0.3秒，刷新频率这里进行调整
 
}

