
#include <Wire.h> //I2C Arduino Library
#include <LiquidCrystal.h>   //调用arduino自带的LiquidCrystal库
LiquidCrystal lcd(10, 8,  9);//设置LCD接口
#define address 0x1E //0011110b, I2C 7bit address of HMC5883
void setup(){
  lcd.begin(16, 2);  //初始化LCD
  //Initialize Serial and I2C communications
  Serial.begin(9600);
  Wire.begin();
  
  //Put the HMC5883 IC into the correct operating mode
  Wire.beginTransmission(address); //open communication with HMC5883
  Wire.send(0x02); //select mode register
  Wire.send(0x00); //continuous measurement mode
  Wire.endTransmission();
  lcd.setBacklight(HIGH);
}

void loop(){
  
  int x,y,z; //triple axis data

  //Tell the HMC5883 where to begin reading data
  Wire.beginTransmission(address);
  Wire.send(0x03); //select register 3, X MSB register
  Wire.endTransmission();
  
 
 //Read data from each axis, 2 registers per axis
  Wire.requestFrom(address, 6);
  if(6<=Wire.available()){
    x = Wire.receive()<<8; //X msb
    x |= Wire.receive(); //X lsb
    z = Wire.receive()<<8; //Z msb
    z |= Wire.receive(); //Z lsb
    y = Wire.receive()<<8; //Y msb
    y |= Wire.receive(); //Y lsb
  }
  
  //Print out values of each axis
   lcd.clear(); //清屏
   lcd.print("x: ");
   lcd.print(x);
   lcd.setCursor(8, 0);
   lcd.print("  y: ");
   lcd.print(y);
   lcd.setCursor(0, 1);
   lcd.print("  z: ");
   lcd.print(z);
  
  delay(250);
}
